From: l00643034 <lishengjie12@huawei.com>
Date: Wed, 12 Jun 2024 22:45:00 +0800
Subject: [PATCH] add virtcca

---
 CMakeLists.txt                                |  17 +-
 build.sh                                      | 309 +++++++++++++
 cmake/CustomInstallDirs.cmake                 |  26 +-
 samples/CMakeLists.txt                        |   2 +
 samples/rats-tls-client/CMakeLists.txt        |   2 +-
 samples/rats-tls-server/CMakeLists.txt        |   2 +-
 samples/sgx-stub-enclave/CMakeLists.txt       |   2 +-
 samples/sgx-stub-enclave/sgx_stub_ecall.c     |   6 +-
 samples/virtcca-client/CMakeLists.txt         |  39 ++
 samples/virtcca-client/ima_measure.c          | 414 ++++++++++++++++++
 samples/virtcca-client/inc/ima_measure.h      |  17 +
 samples/virtcca-client/rats-client.c          | 309 +++++++++++++
 samples/virtcca-client/utils/CMakeLists.txt   |  19 +
 samples/virtcca-server/CMakeLists.txt         |  25 ++
 samples/virtcca-server/rats-server.c          | 350 +++++++++++++++
 src/CMakeLists.txt                            |   9 +-
 src/api/rats_tls_init.c                       |   8 -
 src/attesters/CMakeLists.txt                  |   4 +
 src/attesters/api/enclave_attester_register.c |  29 +-
 src/attesters/csv/collect_evidence.c          |   3 +-
 src/attesters/csv/pre_init.c                  |  11 +-
 .../internal/rtls_enclave_attester_load_all.c |  15 +-
 src/attesters/tdx-ecdsa/pre_init.c            |   1 +
 src/attesters/virtcca/CMakeLists.txt          |  30 ++
 src/attesters/virtcca/cleanup.c               |  14 +
 src/attesters/virtcca/collect_evidence.c      |  67 +++
 src/attesters/virtcca/init.c                  |  29 ++
 src/attesters/virtcca/main.c                  |  33 ++
 src/attesters/virtcca/pre_init.c              |   9 +
 src/core/cpu.c                                | 123 ++++--
 src/core/dice.c                               |  66 ++-
 src/core/main.c                               |   4 +-
 src/core/rtls_common.c                        |  80 ++--
 src/core/rtls_core_generate_certificate.c     |  33 +-
 .../internal/rtls_crypto_wrapper_load_all.c   |  18 +-
 src/include/internal/attester.h               |   2 +
 src/include/internal/core.h                   |   2 +
 src/include/internal/cpu.h                    |   1 +
 src/include/internal/crypto_wrapper.h         |   2 +
 src/include/internal/dice.h                   |   4 +
 src/include/internal/tls_wrapper.h            |   2 +
 src/include/internal/verifier.h               |   2 +
 src/include/rats-tls/api.h                    |   8 +-
 src/include/rats-tls/attester.h               |  18 +-
 src/include/rats-tls/cert.h                   |   8 +
 src/include/rats-tls/err.h                    |   1 +
 src/include/rats-tls/log.h                    |   8 +
 src/include/rats-tls/nonce.h                  |   6 +
 src/include/rats-tls/tls_wrapper.h            |   4 +-
 src/include/rats-tls/verifier.h               |  14 +-
 ...tls_wrapper_verify_certificate_extension.c |  99 +++--
 src/tls_wrappers/nulltls/negotiate.c          |   4 +-
 src/tls_wrappers/nulltls/receive.c            |   2 +-
 src/tls_wrappers/nulltls/transmit.c           |   2 +-
 src/tls_wrappers/openssl/CMakeLists.txt       |   1 +
 src/tls_wrappers/openssl/get_nonce.c          |  49 +++
 src/tls_wrappers/openssl/main.c               |   3 +
 src/tls_wrappers/openssl/negotiate.c          |   9 +-
 src/tls_wrappers/openssl/un_negotiate.c       |  38 +-
 src/tls_wrappers/openssl/use_cert.c           |   4 +-
 src/tls_wrappers/openssl/use_privkey.c        |   2 +-
 src/tls_wrappers/openssl/x509_openssl10x.c    |   3 +-
 src/verifiers/CMakeLists.txt                  |   8 +-
 .../internal/rtls_enclave_verifier_select.c   |   2 +-
 src/verifiers/sev-snp/pre_init.c              |  33 +-
 src/verifiers/sev/pre_init.c                  |  11 +-
 src/verifiers/virtcca/CMakeLists.txt          |  39 ++
 src/verifiers/virtcca/cleanup.c               |  20 +
 src/verifiers/virtcca/init.c                  |  23 +
 src/verifiers/virtcca/main.c                  |  33 ++
 src/verifiers/virtcca/pre_init.c              |  15 +
 src/verifiers/virtcca/verify_evidence.c       |  64 +++
 72 files changed, 2430 insertions(+), 241 deletions(-)
 create mode 100644 build.sh
 create mode 100644 samples/virtcca-client/CMakeLists.txt
 create mode 100644 samples/virtcca-client/ima_measure.c
 create mode 100644 samples/virtcca-client/inc/ima_measure.h
 create mode 100644 samples/virtcca-client/rats-client.c
 create mode 100644 samples/virtcca-client/utils/CMakeLists.txt
 create mode 100644 samples/virtcca-server/CMakeLists.txt
 create mode 100644 samples/virtcca-server/rats-server.c
 create mode 100644 src/attesters/virtcca/CMakeLists.txt
 create mode 100644 src/attesters/virtcca/cleanup.c
 create mode 100644 src/attesters/virtcca/collect_evidence.c
 create mode 100644 src/attesters/virtcca/init.c
 create mode 100644 src/attesters/virtcca/main.c
 create mode 100644 src/attesters/virtcca/pre_init.c
 create mode 100644 src/include/rats-tls/nonce.h
 create mode 100644 src/tls_wrappers/openssl/get_nonce.c
 create mode 100644 src/verifiers/virtcca/CMakeLists.txt
 create mode 100644 src/verifiers/virtcca/cleanup.c
 create mode 100644 src/verifiers/virtcca/init.c
 create mode 100644 src/verifiers/virtcca/main.c
 create mode 100644 src/verifiers/virtcca/pre_init.c
 create mode 100644 src/verifiers/virtcca/verify_evidence.c

diff --git a/CMakeLists.txt b/CMakeLists.txt
index a6585fb..a85336a 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -23,7 +23,7 @@ option(BUILD_FUZZ "Use lib-fuzzer to fuzz the code, default OFF" OFF)
 
 # Define build mode
 set(RATS_TLS_BUILD_MODE "host"
-    CACHE STRING "Select build mode for rats-tls(normal|occlum|sgx)")
+    CACHE STRING "Select build mode for rats-tls(normal|occlum|sgx|virtcca)")
 
 # Print build mode
 message(STATUS "Build Mode: ${RATS_TLS_BUILD_MODE}")
@@ -38,6 +38,7 @@ set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
 #  occlum: OCCLUM
 #  sgx: SGX
 #  tdx: TDX
+#  virtcca: VirtCCA
 if(RATS_TLS_BUILD_MODE STREQUAL "host")
     set(HOST 1)
     add_definitions(-DHOST)
@@ -51,12 +52,14 @@ elseif(RATS_TLS_BUILD_MODE STREQUAL "sgx")
     else()
         message(STATUS "Found intel sgx sdk.")
     endif()
-
     set(SGX 1)
     add_definitions(-DSGX)
 elseif(RATS_TLS_BUILD_MODE STREQUAL "tdx")
     set(TDX 1)
     add_definitions(-DTDX)
+elseif(RATS_TLS_BUILD_MODE STREQUAL "virtcca")
+    set(VIRTCCA 1)
+    add_definitions(-DVIRTCCA)
 else()
     message(FATAL_ERROR "Invalid build mode!")
 endif()
@@ -86,6 +89,16 @@ else()
     message(FATAL_ERROR "Invalid build type!")
 endif()
 
+set(RATS_TLS_INSTALL_PATH_DEFAULT "/usr/lib/rats-tls")
+
+# Define install path
+set(RATS_TLS_INSTALL_PATH "${RATS_TLS_INSTALL_PATH_DEFAULT}" CACHE STRING 
+    "Absoluate path to install the .so and .h")
+
+# Define sample path
+set(RATS_TLS_INSTALL_BIN_PATH "/usr/share/rats-tls/samples" CACHE STRING 
+    "Absoluate path to install the sample bin")
+
 # Include custom modules
 include(CustomInstallDirs)
 include(CompilerOptions)
diff --git a/build.sh b/build.sh
new file mode 100644
index 0000000..7885e43
--- /dev/null
+++ b/build.sh
@@ -0,0 +1,309 @@
+#!/bin/bash
+# Copyright Huawei Technologies Co., Ltd. 2021-2021. All rights reserved.
+set -e
+
+export ROOT_DIR=$(cd $(dirname "$0"); pwd -P)
+export BUILD_DIR="${ROOT_DIR}"/build
+export OUTPUT_DIR="${ROOT_DIR}"/output
+export SAMPLE_DIR=${OUTPUT_DIR}
+export USR_COMPILER_CC=""
+export BUILD_TYPE=""
+export CLEAN_ENABLED=false
+export BUILD_SAMPLES=off
+export BUILD_FUZZ=off
+export RATS_TLS_BUILD_MODE="virtcca"
+export ARCH="arm64"
+export CROSS_COMPILE
+export CC
+export CXX
+export RATS_TLS_LOG_LEVLE="info"
+
+REMOTE_COMIPLE=OFF
+
+print_help() {
+    echo -e "\nUsage:"
+    echo -e "    build.sh [options]...\n"
+    echo -e "Options:"
+    echo -e "    -v, --usrcompiler compiler for target." 
+    echo -e "        Default value is \"aarch64-linux-gnu-gcc\"\n"
+    echo -e "    -b, --buildtype"
+    echo -e "        Select the build type from debug|prerelease|release. Default value is \"debug\"\n"
+    echo -e "    -c, --clean"
+    echo -e "        Clean all the files from previous build, default false.\n"
+    echo -e "    -s, --sample"
+    echo -e "        Build samples,default false.\n"
+    echo -e "    -f, --fuzz"
+    echo -e "        Build fuzz, default false.\n"
+    echo -e "    -S, --run_server"
+    echo -e "        Run svirtcca-server.\n"
+    echo -e "    -C, --run_client"
+    echo -e "        Run virtcca-client.\n"
+    echo -e "    --sample_client"
+    echo -e "        Run rats-tls-clinet.\n"
+    echo -e "    --sample_server"
+    echo -e "        Run rats-tls-server.\n"
+    echo -e "    -h, --help"
+    echo -e "        Display this help and exit.\n"
+}
+
+run_server() {
+    export LD_LIBRARY_PATH=${OUTPUT_DIR}/lib/rats-tls:$LD_LIBRARY_PATH
+    export RATS_TLS_GLOBAL_LOG_LEVEL=${RATS_TLS_LOG_LEVLE}
+    echo ${LD_LIBRARY_PATH}
+    cd ${SAMPLE_DIR}
+    ./virtcca-server -l ${RATS_TLS_LOG_LEVLE}
+}
+
+run_client() {
+    export LD_LIBRARY_PATH=${OUTPUT_DIR}/lib/rats-tls:$LD_LIBRARY_PATH
+    export RATS_TLS_GLOBAL_LOG_LEVEL=${RATS_TLS_LOG_LEVLE}
+    echo ${LD_LIBRARY_PATH}
+    cd ${SAMPLE_DIR}
+    ./virtcca-client -l ${RATS_TLS_LOG_LEVLE}
+}
+
+sample_client() {
+    export LD_LIBRARY_PATH=${OUTPUT_DIR}/lib/rats-tls:$LD_LIBRARY_PATH
+    export RATS_TLS_GLOBAL_LOG_LEVEL=${RATS_TLS_LOG_LEVLE}
+    echo ${LD_LIBRARY_PATH}
+    cd ${SAMPLE_DIR}
+    ./rats-tls-client -l ${RATS_TLS_LOG_LEVLE}
+}
+
+sample_server() {
+    export LD_LIBRARY_PATH=${OUTPUT_DIR}/lib/rats-tls:$LD_LIBRARY_PATH
+    export RATS_TLS_GLOBAL_LOG_LEVEL=${RATS_TLS_LOG_LEVLE}
+    echo ${LD_LIBRARY_PATH}
+    cd ${SAMPLE_DIR}
+    ./rats-tls-server -l ${RATS_TLS_LOG_LEVLE}
+}
+
+#########################################
+# Parse Input Parameters
+#########################################
+! getopt --test > /dev/null
+if [[ ${PIPESTATUS[0]} -ne 4 ]]; then
+    echo 'getopt is not the enhanced version.'
+    exit 1
+fi
+
+OPTIONS=rb:v:csfSCh
+LONGOPTS=remote,usrcompiler:,buildtype:,clean,sample,fuzz,run_server,run_client,help,sample_client,sample_server
+
+! PARSED=$(getopt --options=$OPTIONS --longoptions=$LONGOPTS --name "build" -- "$@")
+if [[ ${PIPESTATUS[0]} -ne 0 ]]; then
+    print_help
+    exit 2
+fi
+
+# reset parameters
+eval set -- "$PARSED"
+
+while true; do
+    case "${1}" in
+        -h|--help)
+            print_help
+            exit 0
+            ;;
+        -r|--remote)
+            REMOTE_COMIPLE=ON
+            shift
+            ;;
+        -S|--run_server)
+            run_server
+            exit 0
+            ;;
+        -C|--run_client)
+            run_client
+            exit 0
+            ;;
+        --sample_server)
+            sample_server
+            exit 0
+            ;;
+        --sample_client)
+            sample_client
+            exit 0
+            ;;
+        -b|--buildtype)
+            BUILD_TYPE="${2}"
+            shift 2
+            ;;
+        -v|--usrcompiler)
+            USR_COMPILER_CC="${2}"
+            shift 2
+            ;;
+        -c|--clean)
+            CLEAN_ENABLED="true"
+            shift
+            ;;
+        -s|--sample)
+            BUILD_SAMPLES=on
+            shift
+            ;;
+        -f|--fuzz)
+            BUILD_FUZZ=on
+            shift
+            ;;
+        --)
+            shift
+            break
+            ;;
+        *)
+            echo "Programming error"
+            exit 3
+            ;;
+    esac
+done
+
+#########################################
+# Check Input Parameters
+#########################################
+
+if [[ -z "${CXX}" ]]; then
+    CXX=$(which g++)
+fi
+
+if [[ "${USR_COMPILER_CC}" == "" ]]; then
+    USR_COMPILER_CC=aarch64-linux-gnu-gcc
+elif [ "${USR_COMPILER_CC}" != "aarch64-linux-gnu-gcc" ] && 
+     [ "${USR_COMPILER_CC}" != "gcc" ]; then
+    echo "ERROR: your input compiler is not support: ${USR_COMPILER_CC}"
+    print_help
+    exit 1
+fi
+if [[ -z "${CC}" ]]; then
+    CC="${USR_COMPILER_CC}"
+fi
+
+#set compile item
+if [[ "${USR_COMPILER_CC}" == "gcc" ]]; then
+    CROSS_COMPILE=""
+else
+    CROSS_COMPILE=$(echo "${USR_COMPILER_CC%-*}-")
+fi
+
+if [[ "${BUILD_TYPE}" == "" ]]; then
+    BUILD_TYPE="debug"
+elif [ "${BUILD_TYPE}" != "debug" ] &&
+     [ "${BUILD_TYPE}" != "prerelease" ] && 
+     [ "${BUILD_TYPE}" != "release" ]; then
+     echo "ERROR: your input build type is not support: ${BUILD_TYPE}"
+     print_help
+    exit 1
+fi
+
+echo -e "\nRATS-TLS compiling info:"
+echo -e "user c++ compiler    = ${CXX}"
+echo -e "user c compiler      = ${CC}"
+echo -e "build type           = ${BUILD_TYPE}"
+echo -e "clean enabled        = ${CLEAN_ENABLED}"
+echo -e "building dir         = ${BUILD_DIR}"
+echo -e "output dir           = ${OUTPUT_DIR}\n"
+
+#########################################
+# Compiling Process
+#########################################
+ echo -e "INFO: compiling..."
+
+if [[ "${CLEAN_ENABLED}" == "true" ]]; then
+    [ -n "${BUILD_DIR}" ] && rm -rf "${BUILD_DIR}"
+    [ -n "${OUTPUT_DIR}" ] && rm -rf "${OUTPUT_DIR}"
+fi
+
+mkdir -p "${BUILD_DIR}"
+mkdir -p "${OUTPUT_DIR}"
+
+pushd "${BUILD_DIR}"
+
+cmake -DRATS_TLS_BUILD_MODE=${RATS_TLS_BUILD_MODE} \
+      -DRATS_TLS_BUILD_TYPE=${BUILD_TYPE} \
+      -DBUILD_SAMPLES=${BUILD_SAMPLES} \
+      -DBUILD_FUZZ=${BUILD_FUZZ} \
+      -DSGX_HW=off \
+      -DSGX_LVI_MITIGATION=off \
+      -DRATS_TLS_INSTALL_PATH=${OUTPUT_DIR} \
+      -DRATS_TLS_INSTALL_BIN_PATH=${SAMPLE_DIR} \
+      -DREMOTE_COMIPLE=${REMOTE_COMIPLE} ..
+
+make -C ${BUILD_DIR} install
+popd
+echo "INFO: building rats-tls finished..."
+
+echo "INFO: generating shell script..."
+target_script=${OUTPUT_DIR}/run.sh
+cat > ${target_script} << EOF
+#!/bin/bash
+set -e
+
+export RATS_TLS_LOG_LEVLE="${RATS_TLS_LOG_LEVLE}"
+
+run_server() {
+    export LD_LIBRARY_PATH=/usr/lib/rats-tls:\$LD_LIBRARY_PATH
+    export RATS_TLS_GLOBAL_LOG_LEVEL=\${RATS_TLS_LOG_LEVLE}
+    echo \${LD_LIBRARY_PATH}
+    ./virtcca-server -l \${RATS_TLS_LOG_LEVLE} -I
+}
+
+run_client() {
+    export LD_LIBRARY_PATH=/usr/lib/rats-tls:\$LD_LIBRARY_PATH
+    export RATS_TLS_GLOBAL_LOG_LEVEL=\${RATS_TLS_LOG_LEVLE}
+    echo \${LD_LIBRARY_PATH}
+    ./virtcca-client -l \${RATS_TLS_LOG_LEVLE}
+}
+
+run_server_sample() {
+    export LD_LIBRARY_PATH=/usr/lib/rats-tls:\$LD_LIBRARY_PATH
+    export RATS_TLS_GLOBAL_LOG_LEVEL=\${RATS_TLS_LOG_LEVLE}
+    echo \${LD_LIBRARY_PATH}
+    ./rats-tls-server -l \${RATS_TLS_LOG_LEVLE}
+}
+
+run_client_sample() {
+    export LD_LIBRARY_PATH=/usr/lib/rats-tls:\$LD_LIBRARY_PATH
+    export RATS_TLS_GLOBAL_LOG_LEVEL=\${RATS_TLS_LOG_LEVLE}
+    echo \${LD_LIBRARY_PATH}
+    ./rats-tls-client -l \${RATS_TLS_LOG_LEVLE}
+}
+
+install() {
+    rm -rf /usr/lib/rats-tls
+    rm -rf /usr/local/include/rats-tls
+    mv -f lib/rats-tls /usr/lib/rats-tls
+    mv -f include/rats-tls /usr/local/include/rats-tls
+}
+
+if [ "\$1" == "server" ]
+then
+      run_server
+fi
+
+if [ "\$1" == "client" ]
+then
+      run_client
+fi
+
+if [ "\$1" == "sserver" ]
+then
+      run_server_sample
+fi
+
+if [ "\$1" == "sclient" ]
+then
+      run_client_sample
+fi
+
+if [ "\$1" == "install" ]
+then
+      install
+fi
+EOF
+
+chmod +x ${target_script}
+
+echo "INFO: warpping output..."
+BIN_DIR="${ROOT_DIR}"/bin
+rm -rf ${BIN_DIR}
+mkdir -p ${BIN_DIR}
+pushd "${OUTPUT_DIR}"
+tar -czvf ${BIN_DIR}/rats-tls.tar.gz  *
\ No newline at end of file
diff --git a/cmake/CustomInstallDirs.cmake b/cmake/CustomInstallDirs.cmake
index d6be5bf..83588f1 100644
--- a/cmake/CustomInstallDirs.cmake
+++ b/cmake/CustomInstallDirs.cmake
@@ -1,27 +1,41 @@
-# /usr/local
-set(RATS_TLS_INSTALL_PATH "/usr/local")
-
 # lib/rats_tls
 set(RATS_TLS_INSTALL_LIB_PATH "${RATS_TLS_INSTALL_PATH}/lib/rats-tls")
 
 # rats_tls/crypto-wrappers
 set(RATS_TLS_INSTALL_LIBCW_PATH "${RATS_TLS_INSTALL_LIB_PATH}/crypto-wrappers")
+if(REMOTE_COMIPLE)
+    add_definitions(-DCRYPTO_WRAPPERS_DIR="${RATS_TLS_INSTALL_PATH_DEFAULT}/crypto-wrappers/")
+else()
+    add_definitions(-DCRYPTO_WRAPPERS_DIR="${RATS_TLS_INSTALL_LIBCW_PATH}/")
+endif()
 
 # rats_tls/attesters
 set(RATS_TLS_INSTALL_LIBA_PATH "${RATS_TLS_INSTALL_LIB_PATH}/attesters")
+if(REMOTE_COMIPLE)
+    add_definitions(-DENCLAVE_ATTESTERS_DIR="${RATS_TLS_INSTALL_PATH_DEFAULT}/attesters/")
+else()
+    add_definitions(-DENCLAVE_ATTESTERS_DIR="${RATS_TLS_INSTALL_LIBA_PATH}/")
+endif()
 
 # rats_tls/verifiers
 set(RATS_TLS_INSTALL_LIBV_PATH "${RATS_TLS_INSTALL_LIB_PATH}/verifiers")
+if(REMOTE_COMIPLE)
+    add_definitions(-DENCLAVE_VERIFIERS_DIR="${RATS_TLS_INSTALL_PATH_DEFAULT}/verifiers/")
+else()
+    add_definitions(-DENCLAVE_VERIFIERS_DIR="${RATS_TLS_INSTALL_LIBV_PATH}/")
+endif()
 
 # rats_tls/tls-wrappers
 set(RATS_TLS_INSTALL_LIBTW_PATH "${RATS_TLS_INSTALL_LIB_PATH}/tls-wrappers")
+if(REMOTE_COMIPLE)
+    add_definitions(-DTLS_WRAPPERS_DIR="${RATS_TLS_INSTALL_PATH_DEFAULT}/tls-wrappers/")
+else()
+    add_definitions(-DTLS_WRAPPERS_DIR="${RATS_TLS_INSTALL_LIBTW_PATH}/")
+endif()
 
 # include/rats_tls
 set(RATS_TLS_INSTALL_INCLUDE_PATH "${RATS_TLS_INSTALL_PATH}/include/rats-tls")
 
-# rats_tls/sample
-set(RATS_TLS_INSTALL_BIN_PATH "/usr/share/rats-tls/samples")
-
 # sgx sdk
 if(EXISTS $ENV{SGX_SDK})
     set(SGXSDK_INSTALL_PATH "$ENV{SGX_SDK}")
diff --git a/samples/CMakeLists.txt b/samples/CMakeLists.txt
index c77319e..dca3333 100644
--- a/samples/CMakeLists.txt
+++ b/samples/CMakeLists.txt
@@ -1,5 +1,7 @@
 add_subdirectory(rats-tls-client)
 add_subdirectory(rats-tls-server)
+add_subdirectory(virtcca-server)
+add_subdirectory(virtcca-client)
 if(SGX)
     add_subdirectory(sgx-stub-enclave)
 endif()
diff --git a/samples/rats-tls-client/CMakeLists.txt b/samples/rats-tls-client/CMakeLists.txt
index 4fd68a4..bfbbaff 100644
--- a/samples/rats-tls-client/CMakeLists.txt
+++ b/samples/rats-tls-client/CMakeLists.txt
@@ -67,4 +67,4 @@ else()
 endif()
 
 install(TARGETS ${PROJECT_NAME}
-	DESTINATION /usr/share/rats-tls/samples)
+	DESTINATION ${RATS_TLS_INSTALL_BIN_PATH})
diff --git a/samples/rats-tls-server/CMakeLists.txt b/samples/rats-tls-server/CMakeLists.txt
index 1e3d0b9..c70293d 100644
--- a/samples/rats-tls-server/CMakeLists.txt
+++ b/samples/rats-tls-server/CMakeLists.txt
@@ -68,4 +68,4 @@ else()
 endif()
 
 install(TARGETS ${PROJECT_NAME}
-	DESTINATION /usr/share/rats-tls/samples)
+	DESTINATION ${RATS_TLS_INSTALL_BIN_PATH})
diff --git a/samples/sgx-stub-enclave/CMakeLists.txt b/samples/sgx-stub-enclave/CMakeLists.txt
index 8b1293e..1e9875b 100644
--- a/samples/sgx-stub-enclave/CMakeLists.txt
+++ b/samples/sgx-stub-enclave/CMakeLists.txt
@@ -76,4 +76,4 @@ enclave_sign(sgx_stub_enclave KEY sgx_stub_enclave.pem CONFIG sgx_stub_enclave.x
 add_dependencies(sgx_stub_enclave rats_tls)
 
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/sgx_stub_enclave.signed.so
-        DESTINATION /usr/share/rats-tls/samples)
+        DESTINATION ${RATS_TLS_INSTALL_BIN_PATH})
diff --git a/samples/sgx-stub-enclave/sgx_stub_ecall.c b/samples/sgx-stub-enclave/sgx_stub_ecall.c
index 4d05bd5..9a6f20e 100644
--- a/samples/sgx-stub-enclave/sgx_stub_ecall.c
+++ b/samples/sgx-stub-enclave/sgx_stub_ecall.c
@@ -127,7 +127,7 @@ int ecall_rtls_server_startup(rats_tls_log_level_t log_level, char *attester_typ
 	uint32_t addrlen_in = sizeof(c_addr);
 	uint32_t addrlen_out;
 	while (1) {
-		RTLS_INFO("Waiting for a connection from client ...\n");
+		RTLS_INFO("Waiting for a connection ...\n");
 
 		int64_t connd;
 		sgx_status = ocall_accept(&connd, sockfd, &c_addr, addrlen_in, &addrlen_out);
@@ -255,7 +255,7 @@ int ecall_rtls_client_startup(rats_tls_log_level_t log_level, char *attester_typ
 	if (verdictd)
 		msg = "{ \"command\": \"echo\", \"data\": \"Hello and welcome to RATS-TLS!\\n\" }";
 	else
-		msg = "\033[94mHello and welcome to RATS-TLS!\033[0m\n";
+		msg = "Hello and welcome to RATS-TLS!\n";
 
 	size_t len = strlen(msg);
 	ret = rats_tls_transmit(handle, (void *)msg, &len);
@@ -299,7 +299,7 @@ int ecall_rtls_client_startup(rats_tls_log_level_t log_level, char *attester_typ
 	}
 
 	if (verdictd)
-		msg = "\033[94mHello and welcome to RATS-TLS!\033[0m\n";
+		msg = "Hello and welcome to RATS-TLS!\n";
 
 	/* Sanity check whether the response is expected */
 	if (strcmp(msg, buf)) {
diff --git a/samples/virtcca-client/CMakeLists.txt b/samples/virtcca-client/CMakeLists.txt
new file mode 100644
index 0000000..6e6b036
--- /dev/null
+++ b/samples/virtcca-client/CMakeLists.txt
@@ -0,0 +1,39 @@
+# Project name
+project(virtcca-client)
+
+# add_subdirectory(t_cose)
+add_subdirectory(utils)
+
+set(CMAKE_C_FLAGS "-fPIE ${CMAKE_C_FLAGS}")
+set(INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../../src/include
+                    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/include/edl
+                    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/include/rats-tls
+                    ${RATS_TLS_INSTALL_INCLUDE_PATH}
+                    ${RATS_TLS_INSTALL_INCLUDE_PATH}/edl
+                    ${CMAKE_CURRENT_SOURCE_DIR}/inc
+                    ${CMAKE_CURRENT_SOURCE_DIR}/t_cose/inc
+                    )
+set(LIBRARY_DIRS ${RATS_TLS_INSTALL_LIB_PATH})
+
+
+include_directories(${INCLUDE_DIRS})
+link_directories(${LIBRARY_DIRS})
+
+# Set source file
+set(SOURCES rats-client.c token_parse.c token_validate.c ima_measure.c)
+
+# Generate bin file
+add_executable(${PROJECT_NAME} ${SOURCES})
+target_link_libraries(${PROJECT_NAME} rats_tls utils t_cose qcbor crypto m)
+
+install(TARGETS ${PROJECT_NAME}
+	    DESTINATION ${RATS_TLS_INSTALL_BIN_PATH})
+
+
+# Install aik_cert.pem to output directory when in Debug mode
+if(DEBUG)
+    set(EXAMPLE_AIK_CERT "${CMAKE_CURRENT_SOURCE_DIR}/aik_cert.pem")
+    install(FILES ${EXAMPLE_AIK_CERT}
+            DESTINATION ${RATS_TLS_INSTALL_BIN_PATH})
+    message(STATUS "Copy ${EXAMPLE_AIK_CERT} to ${RATS_TLS_INSTALL_BIN_PATH} when installing")
+endif()
